## mrbuild 1.2

=== build_examples/GNU_Make/Makefile ===
# -*- Makefile -*-

PYTHON_VERSION_FOR_EXTENSIONS := 3
include /usr/include/mrbuild/Makefile.common.header

# This is a sample Makefile using the Makefile.common infrastructure. A quick
# way to bootstrap a new project is to copy this file to the root directory of
# the project and then to modify each variable to fit that particular project.

# The name of the project. By convention, libraries should be called lib... but
# this isn't required
PROJECT_NAME := libfrobnicator

# The version of the library. We treat the major version as the version of the
# ABI/API. So every time we change the ABI or an API in a backwards-incompatible
# way, we bump the ABI_VERSION. If we make non-breaking changes, bumping the
# TAIL_VERSION is sufficient. In this example, the full version is 0.1
ABI_VERSION  := 0
TAIL_VERSION := 1

# Build all C and C++ sources in src/ into the library
LIB_SOURCES := src/*.c*

# Build all C and C++ sources in bin/ into separate executables
BIN_SOURCES := bin/*.c*

# If bin/run_foo.c exists, it is picked up in BIN_SOURCES, and the bin/run_foo
# executable will be built from the library and bin/run_foo.o (built from
# bin/run_foo.c). This is the default behavior and nothing needs to be specified

# I specify that bin/run_foo2 consists of the library and bin/run_foo2.o (as
# usual) AND links with bin/run_foo2_extra.o. The latter will be built from
# bin/run_foo2_extra.c (or .cc or .cpp and so on, whichever exists)
bin/run_foo2: bin/run_foo2_extra.o

# Suppose I have bin/run_foo3.c to build bin/run_foo3. And suppose bin/run_foo3
# needs to additionally build with sources generated from run_foo3.in: the .o
# links with bin/run_foo3_generated.o (built from bin/run_foo3_generated.c) and
# the .c #includes run_foo3_generated.h, and that both of these are generated
# from run_foo3.in. We specify this in the usual way, with a tiny bit of
# mrbuild-specific stuff:
run_foo3:   run_foo3_generated.o
run_foo3.o: run_foo3_generated.h
%3_generated.h %3_generated.c: %3.in
	make_generated_files $<
EXTRA_CLEAN += run_foo3_generated.h run_foo3_generated.c
# If we're using gengetopt to generate the sources, the build rule and the
# EXTRA_CLEAN list above are provided in mrbuild, and can be omitted.

# Any extra flags to pass to the C and C++ compilers. The build system always
# builds with debugging information and (if no other -O flag is given) with
# optimization. Use += to not override any settings from the commandline
CCXXFLAGS += -Wno-unused-parameter

# Extra flags to pass to the C compiler when building src/bleh.o from src/bleh.c
src/bleh.o: CFLAGS += -DFOO

# Link bin/run_foo with -lbar. Do NOT link the library with -lbar.
bin/run_foo: LDLIBS += -lbar

# Link all the executables AND the library with -lzap
LDLIBS += -lzap

# If we have doxygen docs, we can state the rule to build them. Everything will
# be built into doxygen-doc/, the DIST_DOC and DIST_MAN distribution lists below
# install the man-pages and the html docs
doc: doxygen-doc/
doxygen-doc/: frobnicator.dox
	SRCDIR='.' PROJECT='frobnicator' DOCDIR=$@ VERSION='$(VERSION)' PERL_PATH='/bin/perl' HAVE_DOT='YES' DOT_PATH='/bin' GENERATE_MAN='YES' GENERATE_RTF='NO' GENERATE_XML='NO' GENERATE_HTMLHELP='NO' GENERATE_CHI='NO' GENERATE_HTML='YES' GENERATE_LATEX='NO' doxygen $<
doxygen-doc/%: doxygen-doc/ ;
.PHONY: doc
EXTRA_CLEAN += doxygen-doc

# distribute (in a 'make install' and thus into the package) all headers in src/
# except those that match src/*tst*
DIST_INCLUDE        := src/*.h
DIST_INCLUDE_EXCEPT := src/*tst*

# distribute (in a 'make install' and thus into the package) all executables
# built from BIN_SOURCES except bin/*_tst. And ship the python application
DIST_BIN := $(filter-out bin/%_tst,$(wildcard $(BIN_TARGETS))) python-tool

# distribute all generated manpages in section 3 EXCEPT those for the test
# program
DIST_MAN                 := doxygen-doc/man/man3
DIST_MAN_EXCEPT_FINDSPEC := -type f -name '*_tst.3'

# distribute the html documentation
DIST_DOC := doxygen-doc/html


# This is the manpage-generating technique from
# http://notes.secretsauce.net/notes/2018/10/23_manpages-and-readmes.html
#
# generate manpages from distributed binaries, and ship them.
DIST_MAN += $(addsuffix .1,$(DIST_BIN))
$(DIST_MAN): %.1: %.pod
	pod2man --center="title: does something" --name=THING --release="thing 0.1" --section=1 $< $@
%.pod: %
	make-pod-from-help $< > $@
	cat footer.pod >> $@
EXTRA_CLEAN += $(DIST_MAN) $(patsubst %.1,%.pod,$(DIST_MAN))

# This is the python-extension-generating technique from
# http://notes.secretsauce.net/notes/2017/11/14_python-extension-modules-without-setuptools-or-distutils.html
frobnicator_pywrap.o: CFLAGS += $(PY_MRBUILD_CFLAGS)
frobnicator_pywrap.o: $(addsuffix .h,$(wildcard *.docstring))
frobnicator/_frobnicator$(PY_EXT_SUFFIX): frobnicator_pywrap.o libfrobnicator.so
	$(PY_MRBUILD_LINKER) $(PY_MRBUILD_LDFLAGS) $< -lfrobnicator -o $@
# The python libraries (compiled ones and ones written in python) all live in
# frobnicator/
DIST_PY3_MODULES := frobnicator
all: frobnicator/_frobnicator$(PY_EXT_SUFFIX)
EXTRA_CLEAN += frobnicator/*.so


include /usr/include/mrbuild/Makefile.common.footer

## mrbuild 1.1

=== debian/changelog ===
mrbuild (1.1-2) unstable; urgency=medium

  * Source-only upload to migrate to testing

 -- Dima Kogan <dkogan@debian.org>  Mon, 31 Oct 2022 16:30:19 -0700

mrbuild (1.1-1) unstable; urgency=medium

  * Initial upload to Debian (Closes: #1021158)

 -- Dima Kogan <dkogan@debian.org>  Mon, 03 Oct 2022 00:39:05 -0700

=== debian/control ===
Source: mrbuild
Priority: optional
Section: devel
Build-Depends:
# Please do not "fix" to use debhelper-compat. I want this to remain compatible
# with older debian-based distros
 debhelper (>= 11)
Maintainer: Dima Kogan <dkogan@debian.org>
Standards-Version: 4.6.0
Homepage: https://github.com/dkogan/mrbuild
Vcs-Git: https://salsa.debian.org/debian/mrbuild.git
Vcs-Browser: https://salsa.debian.org/debian/mrbuild

Package: mrbuild
Section: devel
Architecture: all
Depends: ${perl:Depends}, ${misc:Depends}
Description: A simple build system
 mrbuild is a simple build system built with GNU Make. It makes it easy to setup
 projects providing some executables, shared libraries, Python extension modules
 and documentation

## mrbuild 1.2

=== debian/changelog ===
mrbuild (1.2-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Thu, 19 Jan 2023 21:20:52 -0800

mrbuild (1.1-4) unstable; urgency=medium

  * Minor debian janitor cleanup

 -- Dima Kogan <dkogan@debian.org>  Sat, 14 Jan 2023 14:45:36 -0800

mrbuild (1.1-3) unstable; urgency=medium

  * mrbuild is Multi-Arch:foreign

 -- Dima Kogan <dkogan@debian.org>  Sat, 14 Jan 2023 14:26:11 -0800

=== debian/control ===
--- 
+++ 
@@ -6,15 +6,15 @@
 # with older debian-based distros
  debhelper (>= 11)
 Maintainer: Dima Kogan <dkogan@debian.org>
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/dkogan/mrbuild
 Vcs-Git: https://salsa.debian.org/debian/mrbuild.git
 Vcs-Browser: https://salsa.debian.org/debian/mrbuild
 
 Package: mrbuild
-Section: devel
 Architecture: all
 Depends: ${perl:Depends}, ${misc:Depends}
+Multi-Arch: foreign
 Description: A simple build system
  mrbuild is a simple build system built with GNU Make. It makes it easy to setup
  projects providing some executables, shared libraries, Python extension modules

## mrbuild 1.5

=== debian/changelog ===
mrbuild (1.5-1) unstable; urgency=medium

  * mrbuild Depends:chrpath
  * New upstream release
    - Build rules extended to work on BSD and OSX boxes
    - Makefile.common removed: you MUST include "Makefile.common.header"
      and "Makefile.common.footer" explicitly

 -- Dima Kogan <dkogan@debian.org>  Thu, 29 Jun 2023 12:07:10 -0700

## mrbuild 1.6

=== debian/changelog ===
mrbuild (1.6-2) unstable; urgency=medium

  * Rebuild to pacify buildd. No changes

 -- Dima Kogan <dkogan@debian.org>  Tue, 08 Aug 2023 22:27:23 -0700

mrbuild (1.6-1) unstable; urgency=medium

  * New upstream release
    - Bug fix: RPATH logic works without Python modules

 -- Dima Kogan <dkogan@debian.org>  Mon, 17 Jul 2023 09:40:33 -0700

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,8 @@
 
 Package: mrbuild
 Architecture: all
-Depends: ${perl:Depends}, ${misc:Depends}
+Depends: ${perl:Depends}, ${misc:Depends},
+  chrpath
 Multi-Arch: foreign
 Description: A simple build system
  mrbuild is a simple build system built with GNU Make. It makes it easy to setup

## mrbuild 1.7

=== debian/changelog ===
mrbuild (1.7-1) unstable; urgency=medium

  * New upstream release
    - The compiler is given MRBUILD_VERSION and not VERSION

 -- Dima Kogan <dkogan@debian.org>  Fri, 03 Nov 2023 12:46:35 -0700

mrbuild (1.6-3) unstable; urgency=medium

  * Short title tweak (Closes: #1052370)

 -- Dima Kogan <dkogan@debian.org>  Sat, 30 Sep 2023 11:48:39 -0700

## mrbuild 1.8

=== debian/changelog ===
mrbuild (1.8-1ubuntu0.24.04.1) noble; urgency=medium

  * Backport changes from Oracular to avoid FTBFS in
    reverse-dependencies with NumPy 1.26 (LP: #2064959)

  [ Dima Kogan ]
  * PY_MRBUILD_CFLAGS get the numpy header path from pkg-config. Fixes
    build errors for users of mrbuild and newer python3-numpy packages.
    See: #1067398
  * Added Depends:pkgconf To provide the "pkg-config" tool for numpy. See:
    #1067349

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 12 Jun 2024 14:39:24 +0000

mrbuild (1.8-1) unstable; urgency=medium

  * New upstream release
    - make-pod-from-help works with tool with no positional arguments

 -- Dima Kogan <dkogan@debian.org>  Tue, 02 Jan 2024 00:32:36 -0800

=== debian/control ===
Source: mrbuild
Priority: optional
Section: devel
Build-Depends:
# Please do not "fix" to use debhelper-compat. I want this to remain compatible
# with older debian-based distros
 debhelper (>= 11)
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Dima Kogan <dkogan@debian.org>
Standards-Version: 4.6.1
Homepage: https://github.com/dkogan/mrbuild
Vcs-Git: https://salsa.debian.org/debian/mrbuild.git
Vcs-Browser: https://salsa.debian.org/debian/mrbuild

Package: mrbuild
Architecture: all
Depends: ${perl:Depends}, ${misc:Depends},
  chrpath,
# To provide pkg-config for numpy
  pkgconf
Multi-Arch: foreign
Description: Simple build system
 mrbuild is a simple build system built with GNU Make. It makes it easy to setup
 projects providing some executables, shared libraries, Python extension modules
 and documentation

## mrbuild 1.10

=== debian/changelog ===
mrbuild (1.10-2) unstable; urgency=medium

  * No-op source-only re-upload

 -- Dima Kogan <dkogan@debian.org>  Mon, 22 Apr 2024 07:29:34 -0700

mrbuild (1.10-1) unstable; urgency=medium

  * New upstream release
    - Support for DEB_BUILD_OPTIONS=noopt

 -- Dima Kogan <dkogan@debian.org>  Fri, 05 Apr 2024 14:29:19 -0700

mrbuild (1.9-2) unstable; urgency=medium

  * Added Depends:pkgconf To provide the "pkg-config" tool for numpy. See:
    #1067349

 -- Dima Kogan <dkogan@debian.org>  Mon, 25 Mar 2024 23:29:41 -0700

mrbuild (1.9-1) unstable; urgency=medium

  * PY_MRBUILD_CFLAGS get the numpy header path from pkg-config. Fixes
    build errors for users of mrbuild and newer python3-numpy packages.
    See: #1067398

 -- Dima Kogan <dkogan@debian.org>  Thu, 21 Mar 2024 16:46:06 -0700

## mrbuild 1.11

=== debian/changelog ===
mrbuild (1.11-1) unstable; urgency=medium

  * New upstream release
    - If available, I use the PKG_CONFIG environment variable
      This makes, for instance, cross-building work

 -- Dima Kogan <dkogan@debian.org>  Fri, 12 Jul 2024 15:41:28 -0700

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,7 @@
 # Please do not "fix" to use debhelper-compat. I want this to remain compatible
 # with older debian-based distros
  debhelper (>= 11)
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Dima Kogan <dkogan@debian.org>
+Maintainer: Dima Kogan <dkogan@debian.org>
 Standards-Version: 4.6.1
 Homepage: https://github.com/dkogan/mrbuild
 Vcs-Git: https://salsa.debian.org/debian/mrbuild.git

## mrbuild 1.13

=== debian/changelog ===
mrbuild (1.13-1) unstable; urgency=medium

  * New upstream release
    - using .NOTINTERMEDIATE if available; otherwise falling back to
    .SECONDARY

 -- Dima Kogan <dkogan@debian.org>  Sun, 08 Sep 2024 12:13:55 -0700

mrbuild (1.12-1) unstable; urgency=medium

  * New upstream release
    - Python modules do NOT link with -lpython
    - I don't mark all files as secondary
    - PY_MRBUILD_CFLAGS extra flags: -Wno-cast-function-type and
      -Wno-int-conversion

 -- Dima Kogan <dkogan@debian.org>  Sat, 24 Aug 2024 20:46:12 -0700

=== debian/control ===
--- 
+++ 
@@ -17,6 +17,11 @@
   chrpath,
 # To provide pkg-config for numpy
   pkgconf
+# for "make install" to work if we have Python modules. See, for instance,
+#   https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1080677
+# This is a non-binding Suggests because we only need this if Python modules are
+# being built
+Suggests: python3-setuptools
 Multi-Arch: foreign
 Description: Simple build system
  mrbuild is a simple build system built with GNU Make. It makes it easy to setup

## mrbuild 1.14

=== debian/changelog ===
mrbuild (1.14-1) unstable; urgency=medium

  * arch-aware tools are accessible to the user

 -- Dima Kogan <dkogan@debian.org>  Thu, 18 Sep 2025 22:10:48 -0700

## mrbuild 1.15

=== build_examples/GNU_Make/Makefile ===
--- 
+++ 
@@ -3,9 +3,10 @@
 PYTHON_VERSION_FOR_EXTENSIONS := 3
 include /usr/include/mrbuild/Makefile.common.header
 
-# This is a sample Makefile using the Makefile.common infrastructure. A quick
-# way to bootstrap a new project is to copy this file to the root directory of
-# the project and then to modify each variable to fit that particular project.
+# This is a sample Makefile using the Makefile.common.header,
+# Makefile.common.footer infrastructure. A quick way to bootstrap a new project
+# is to copy this file to the root directory of the project and then to modify
+# each variable to fit that particular project.
 
 # The name of the project. By convention, libraries should be called lib... but
 # this isn't required

=== debian/changelog ===
mrbuild (1.15-1) unstable; urgency=medium

  * make-pod-from-help REQUIRES an empty line before the options start

 -- Dima Kogan <dkogan@debian.org>  Tue, 30 Sep 2025 18:39:54 -0700

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_build: make-pod-from-help.1
	dh_auto_build

%.1: bin/%
	pod2man --section=1 --center="mrbuild" --name=MRBUILD $< $@

override_dh_auto_clean:
	rm -f make-pod-from-help.1

=== debian/watch ===
version=4
https://github.com/dkogan/mrbuild/tags .*/v?(\d\S+)\.tar\.gz

## mrbuild 1.17

=== debian/changelog ===
mrbuild (1.17-1) unstable; urgency=medium

  * New upstream release
    - The install paths are overrideable
    - Added explicit fortran support for library code

 -- Dima Kogan <dkogan@debian.org>  Thu, 22 Jan 2026 21:56:31 -0800
